#ifndef MS_PLAYER
#define MS_PLAYER
#include <mgba/flags.h>
#include <mgba/core/core.h>
#include <mgba/core/thread.h>
#include <mgba/core/interface.h>
#ifdef M_CORE_GBA
#include <mgba/internal/gba/sio/lockstep.h>
#endif  
#ifdef M_CORE_GB
#include <mgba/internal/gb/sio/lockstep.h>
#endif  

union Node {
    struct GBSIOLockstepNode* gb;
    struct GBASIOLockstepNode* gba;
};

struct msPlayer {
    struct msCoreController* controller;
    union Node node;
    int awake;
    int32_t cyclesPosted;
    unsigned waitMask;
};
#endif
